/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <fs/fs.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>

int fs_next(const char *const path, char **const out, size_t *const i)
{
    char *next = NULL;

    if (*i >= strlen(path))
    {
        *out = NULL;
        return 0;
    }

    const char *const s = &path[*i];

    if (*s == '/')
    {
        if (!(next = strdup("/")))
            goto failure;

        (*i)++;
        *out = next;
        return 0;
    }

    const char *sep = strchr(s, '/');
    next = sep ? strndup(s, sep - s) : strdup(s);

    if (!next)
        goto failure;
    else if (sep)
        while (*sep && *sep == '/')
            sep++;

    *i += sep ? sep - s : strlen(s);
    *out = next;
    return 0;

failure:
    free(next);
    return -1;
}
